/*-
 * Copyright (C)2014 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2014 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n\
@(#)V.M "VERS;
static const char rcsid[] = "$Id: collect.c,v 1.1 2014/08/31 06:34:46 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <stdio.h>
#include "recobe.h"

extern const recobe_c_tdm recobe_text_dm;
extern const recobe_c_tdm recobe_G711_dm;

const recobe_c_tdm
recobe_dm = { 0, "NOTABLE", NULL, NULL, NULL, NULL};

static int
recobe_tst(char nm, int domain) {
    int i, r = -1;

    if  ((domain > RECOBE_NOTABLE) && (domain < recobe_collection.mw)) {
        for (i = 0; i < recobe_collection.dm[domain]->cw; ++i) {
            if  (nm == recobe_collection.dm[domain]->nm[i].n) {
                r = i;
                break;
    }   }   }
    return(r);
}

static u_char *
recobe_get(const char *name, int domain) {
    u_char *t = NULL;
    int i, j, g;

    if  (!!name[0] && !!name[1]) {
        for (g = (!domain ? 1 : domain); g < (!domain ? recobe_collection.mw : domain + 1); ++g) {
            if  ((0 <= (i = recobe_tst(name[0], g))) && (0 <= (j = recobe_tst(name[1], g)))) {
                t = recobe_collection.dm[g]->get(name);
                goto out;
    }   }   }
out:
    return(t);
}

static u_char *
recobe_ind(int domain, int f, int t) {
    u_char *s = NULL;

    s = recobe_collection.dm[domain]->ind(f, t);
    return(s);
}

const recobe_collection_t
/*****************************************************************************************************
 *****************************************************************************************************/
recobe_collection =                                                                              /****
 *****************************************************************************************************
 *****************************************************************************************************/
{ RECOBE_DOMAX
, recobe_tst
, recobe_get
, recobe_ind
, {&recobe_dm, &recobe_text_dm, &recobe_G711_dm, NULL}
};
